// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_ROLE_OFFENSIVE_HALF_H
#define AGENT2D_ROLE_OFFENSIVE_HALF_H

#include "soccer_role.h"

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/sector_2d.h>
#include <rcsc/player/soccer_action.h>

class RoleOffensiveHalf
    : public SoccerRole {
private:

public:
    explicit
    RoleOffensiveHalf( boost::shared_ptr< const rcsc::Formation > f )
        : SoccerRole( f )
      { }

    ~RoleOffensiveHalf()
      { }

    virtual
    void execute( rcsc::PlayerAgent * agent );

    static
    std::string name()
      {
          return std::string( "OffensiveHalf" );
      }
    static
    SoccerRole * create( boost::shared_ptr< const rcsc::Formation > f )
      {
          return ( new RoleOffensiveHalf( f ) );
      }

private:

    void doKick( rcsc::PlayerAgent * agent );
    void doOffensiveKick( rcsc::PlayerAgent * agent );
  bool doDirectPass( rcsc::PlayerAgent * agent, const int target_unum );
  bool doThroughPass( rcsc::PlayerAgent * agent, const int target_unum );

    void doMove( rcsc::PlayerAgent * agent );
    void doOffensiveMove( rcsc::PlayerAgent * agent );
    void doDefensiveMove( rcsc::PlayerAgent * agent );
    double getDashPower( const rcsc::PlayerAgent * agent,
                         const rcsc::Vector2D & target_point );
};

#endif
